
rm(list=ls())
  setwd("~/Dropbox/workspace/london/paper/paper_data/")
library(colorspace)
library(sp)
library(methods)
load("births_annual.Rda")
births=births[as.numeric(row.names(births))>=1560&as.numeric(row.names(births))<=1665,]
births.total=sum(apply(births,1,sum,na.rm=T))
load("deaths_annual.Rda")
deaths=deaths[as.numeric(row.names(deaths))>=1560&as.numeric(row.names(deaths))<=1665,]
sum(apply(deaths,1,sum,na.rm=T))
sum(apply(births,1,sum,na.rm=T))
sum.na=function(x){sum(!is.na(x))}  #count observations
a1=apply(deaths,2,sum.na)
sum(a1==0)   #missing parishes
sum(deaths[19,1:113],na.rm=T)/7830   #fraction of deaths in 1578
sum.na(deaths[19,1:113])
load("london_bills.Rda")
d1=bills$b1636
sum(deaths[77,1:96],na.rm=T)/sum(d1[1:96],na.rm=T)  #fraction of deaths in 1636
sum(deaths[77,98:113],na.rm=T)/sum(d1[98:113],na.rm=T)
sum(deaths[77,c(114 ,116 ,117, 119 ,120, 123, 126, 128 ,129)],na.rm=T)/sum(d1[114:130],na.rm=T)
sum(deaths[77,!is.na(d1)],na.rm=T)/sum(d1,na.rm=T)

#compare totals with imputed totals
load("deaths_imputed.Rda")
deaths.imputed=deaths.imputed[as.numeric(row.names(deaths.imputed))>=1560&as.numeric(row.names(deaths.imputed))<1665,]
deaths=deaths[as.numeric(row.names(deaths))>=1560&as.numeric(row.names(deaths))<1665,]
sum(deaths,na.rm=T)/sum(deaths.imputed)
load("deaths_annual.Rda")
deaths=deaths[as.numeric(row.names(deaths))>=1540&as.numeric(row.names(deaths))<=1665,]
years.obs=function(x){sum(!is.na(x))} 
begin.year=function(x){   #function to get beginning of death records
  years=as.numeric(row.names(deaths))
  ifelse(any(!is.na(x)),
         min(years[!is.na(x)]),NA)
}
parish.obs=data.frame(start=sapply(deaths,begin.year),number=apply(deaths,2,years.obs)) #start year and number of years obs
parish.obs[parish.obs$number<10,"start"]=NA  #fewer than 10 obs treated as missing
parish.obs$start[is.na(parish.obs$start)]=1665
parish.obs[128,]=c(1550,80)   #St martin in the fields
load("map_london.Rda")
l.map=london.map
a1=parish.obs$start
a1=c(a1,rep(NA,nrow(l.map@data)-130))   #add missing start dates for other areas on map
start.date=cut(a1,breaks=c(1530,1560,1600,1664,1700),        labels=c("pre-1561","1561-1600","1601-1664","1665 only"))
start.date=factor(start.date,levels=rev(c("pre-1561","1561-1600","1601-1664","1665 only")))
l.map@data$Start_Date=start.date
br=list("sp.lines",bridge)
rv=list("sp.polygons",river,col="grey",fill = 384)
wl=list("sp.lines",wall,lwd=5,col="black")
#total deaths
deaths=deaths[as.numeric(row.names(deaths))>=1560&as.numeric(row.names(deaths))<=1665,]
deaths.total=sum(apply(deaths,1,sum,na.rm=T))
  
 ####################Figure of starting years############## 
 # <<start_year_map,fig=TRUE,width=6,height=4.5,echo=FALSE,results='hide',cache=TRUE>>=
 pdf("~/Dropbox/workspace/london/paper/figures/start_year.pdf",height=6,width=6)
  par(mar=c(4,5,.1,.3), las=1)
  spplot(l.map,c("Start_Date"),col=grey(0.9), sp.layout=list(rv,wl,br),as.Table=T, 
         col.regions=rev(sequential_hcl(4, c = c(80, 30), l = c(30, 90), power = c(1/5, 1.3))),
         xlim=c(530000,535100),ylim=c(179500,184200))
dev.off()
# ##############export shapefile to scapetoad
# l1.map=l.map[1:130,]
# #d1=as.matrix(deaths.imputed)
# l1.map$deaths=  bills$b1660
# library(maptools)
# writeSpatialShape(l1.map,"london_carto")  
# carto.60=readShapeSpatial("carto60.shp")  #import cartogram
# carto.60$Start_Date=NULL
# carto.60$Start_Date=l1.map$Start_Date
# spplot(carto.60,c("Start_Date"),col=grey(0.9), as.Table=T, 
#        col.regions=rev(sequential_hcl(4, c = c(80, 30), l = c(30, 90), power = c(1/5, 1.3))))

######################Figure of registers versus bills
 # <<registers_vs_bills,fig=TRUE,width=6,height=6,out.width=\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
  rm(list=ls())  
setwd("~/Dropbox/workspace/london/paper/paper_data/")
  library(ggplot2)
  library(gtable) 
  load("london_bills.Rda")
  bills=bills[-127,]
  load("deaths_annual.Rda")
  deaths=deaths[,-127]
  #Compare our parish totals with london bills

  plot.bill=function(year){ 
    d1=data.frame(Bill=bills[,match(paste("b",year,sep=""),names(bills))],
                  Parish=t(deaths[as.numeric(row.names(deaths))==year,]))   
    #Imputed=as.character(rep("Recorded",nrow(bills)))   
    #Imputed[is.na(t(deaths[as.numeric(row.names(deaths))==year,]))]="Imputed"   
    #d1$Imputed=Imputed   
    names(d1)[2]="Parish"   
    #rm(Imputed)   
    d1$Name=bills$Parish   
    d1$Name[d1$Bill<sort(d1$Bill,decreasing=T,na.last=T)[15]]=NA 
    ggplot(d1,aes(x=Bill,y=Parish,label=Name))+geom_point(colour="blue")+
      geom_text(hjust = 0.7, vjust = 2,size=1.5,colour="grey50")+geom_abline(intercept=0,slope=1,colour="grey50")+
      scale_y_sqrt()+ scale_x_sqrt()+xlab("London Bills")+ ylab("Parish Registers") +
      theme_bw()+
      opts(axis.text.x=theme_text(colour="grey50",size=7,angle=90),axis.text.y=theme_text(colour="grey50",size=7,hjust=1),          	axis.title.y=theme_text(colour="grey40",size=9,angle=90),axis.title.x=theme_text(colour="grey40",size=9,angle=0),
           legend.position="none",title=as.character(year)
           ) 
  }
  
  grid.newpage() 
  pdf("~/Dropbox/workspace/london/paper/figures/registers_bills.pdf",height=8,width=8)
  pushViewport(viewport(layout = grid.layout(2,2))) 
  p1 <- plot.bill(1625) 
  p2 <- plot.bill(1636) 
  p3 <- plot.bill(1660) 
  p4 <- plot.bill(1665)
  print(p1, vp=viewport(layout.pos.row=1,layout.pos.col=1))
  print(p2, vp=viewport(layout.pos.row=1,layout.pos.col=2))
  print(p3, vp=viewport(layout.pos.row=2,layout.pos.col=1))
  print(p4, vp=viewport(layout.pos.row=2,layout.pos.col=2)) 
  dev.off()
  
  
  #########################Spatial distribution of wealth#####################################
  #<<wealth,fig=TRUE,width=6,height=2,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
    
  load("parish_wealth.Rda")
  library(colorspace)
  
  load("map_london.Rda")
  l.map=london.map[1:113,]
  l.map@data$"Lay_Subsidy_1582"=cut(parish.wealth$Amount,breaks=quantile(parish.wealth$Amount,na.rm=T),labels=1:4)
  l.map@data$"Substantial_Households_1638"=cut(parish.wealth$Big.houses,breaks=quantile(parish.wealth$Big.houses,na.rm=T),labels=1:4)
  l.map@data$"Hearths_1665"=cut(parish.wealth$Hearths,breaks=quantile(parish.wealth$Hearths,na.rm=T),labels=1:4)
  l.map=l.map[l.map$ward!="Southwark",]
  #rv=list("sp.lines",thames,col="grey")
  br=list("sp.lines",bridge)
  rv=list("sp.polygons",river,col="grey",fill = 384)
  wl=list("sp.lines",wall,lwd=3)
  pdf("~/Dropbox/workspace/london/paper/figures/wealth.pdf",height=6,width=8)
  spplot(l.map,c("Substantial_Households_1638","Lay_Subsidy_1582"),col=grey(.5), layout=c(1,2),sp.layout=list(rv,wl,br),as.Table=T,
         col.regions=rev(sequential_hcl(4, c = c(80, 30), l = c(30, 90), power = c(1/5, 1.3))),
         xlim=c(531300,533850),ylim=c(180500,182000))
  dev.off()
  
  ######################Spatial autocorrelation tests###########
  library(spdep)
  load("map_london.Rda")
  load("parish_wealth.Rda")
  ###############1582 tax payment################
  l.map=london.map[1:97,]
  l.map@data$wealth_1582=parish.wealth$Amount[1:97]
  l.map=l.map[!is.na(l.map@data$wealth_1582),]
  a1=poly2nb(l.map)
  a2=nb2listw(a1)
  geary.test(l.map@data$wealth_1582,a2)
  moran.test(l.map@data$wealth_1582,a2)
  ############percent big houses 1638#############
  l.map=london.map[c(1:36,38:97),]   #omit st james duke place to get everything contiguous
  l.map@data$Big.houses=parish.wealth$Big.houses[c(1:36,38:97)]
  l.map=l.map[!is.na(l.map@data$Big.houses),]
  a1=poly2nb(l.map)
  a2=nb2listw(a1)
  geary.test(l.map@data$Big.houses,a2)
  moran.test(l.map@data$Big.houses,a2)
  

  
  #################################Compare with recorded totals######################
 # <<graunt_compare,fig=TRUE,width=6,height=6,out.width=\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
  rm(list=ls()) 
  library(ggplot2)
  library(gtable) 
  library(reshape)
  library(zoo) 
  load("Graunt_totals.Rda")
  load("deaths_imputed.Rda")
  graunt=data.frame(total.graunt=graunt.totals$total,liberties.graunt=(graunt.totals$city+graunt.totals$liberties),city.graunt=graunt.totals$city)
  graunt=graunt[1:62,]
  graunt=as.zoo(ts(graunt,1603))
   imputed1=data.frame(total.imp=apply(deaths.imputed[,1:130],1,sum),
                       liberties.imp=apply(deaths.imputed[,1:113],1,sum),
                       city.imp=apply(deaths.imputed[,1:97],1,sum))       
  imputed=data.frame(total.imp=apply(deaths.imputed[,-c(115,118,121,122,124,125,127,130)],1,sum),
                     liberties.imp=apply(deaths.imputed[,1:113],1,sum),
                     city.imp=apply(deaths.imputed[,1:97],1,sum))
   imputed[96:124,]=imputed1[96:124,]  #include distant parishes from 1636
  imputed=as.zoo(ts(imputed,1541))
  c1=merge(graunt,imputed)
  c1=as.data.frame(c1)
  names(c1)=c("Graunt.total","Graunt.liberties","Graunt.city","Est.total","Est.liberties","Est.city")
  c1$date=seq(as.Date("1541-01-01"),by="year",length=nrow(c1))
  #c1=c1[11:121,]
  #c1[13,2]=20000; #city and liber in 1563
  c1[38:42,2]=c(7830,3406,2873,3931,6762)  #Creighton bills 78--82
  
  c2=c1[,c("date","Est.city","Graunt.city")]
  names(c2)=c("date","Estimate","London Bills")
  c3=melt(c2,id="date")
  p3=ggplot(c3,aes(x=date, y=value, colour=variable)) + geom_line()+
    theme_bw()+
    xlab("")+ylab("Burials")+scale_colour_hue("")+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="Intra-Mural",
         legend.position="none")
  c2=c1[,c("date","Est.liberties","Graunt.liberties")]
  names(c2)=c("date","Estimate","London Bills")
  c3=melt(c2,id="date")
  p2=ggplot(c3,aes(x=date, y=value, colour=variable)) + geom_line()+
    theme_bw()+
    xlab("")+ylab("Burials")+scale_colour_hue("")+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="Intra- and Extra-Mural",
         legend.position="none")
  c2=c1[,c("date","Est.total","Graunt.total")]
  names(c2)=c("date","Estimate","London Bills")
  c3=melt(c2,id="date")
  p1=ggplot(c3,aes(x=date, y=value, colour=variable)) + geom_line()+
    theme_bw()+
    xlab("")+ylab("Burials")+scale_colour_hue("")+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="London Total",
         legend.position="none")
  
  grid.newpage(); 
  pdf("~/Dropbox/workspace/london/paper/figures/compare_totals.pdf",height=6,width=6)
  pushViewport(viewport(layout = grid.layout(3,1))) ;
  print(p1, vp=viewport(layout.pos.row=1,layout.pos.col=1));
  print(p2, vp=viewport(layout.pos.row=2,layout.pos.col=1));
  print(p3, vp=viewport(layout.pos.row=3,layout.pos.col=1));
dev.off()
  
################################Table of relative mortality#####################
#  <<tabular-relative_mortality, echo=FALSE, results='asis'>>= 
  rm(list=ls())
  setwd("~/Dropbox/workspace/london/paper/paper_data/")
  load("deaths_annual.Rda");
  deaths.parish=deaths[1:120,1:130]
  load("london_bills.Rda");
  bills=bills[1:130,];
  #deaths.parish=deaths.total.mgcv  ;
  deaths.b=t(subset(bills,select=c(b1660,b1661,b1662,b1663,b1664,b1665)));   #from bills
  deaths.b=as.data.frame(deaths.b[,1:130]);
  names(deaths.b)=names(deaths.parish);
  deaths.b[1:5,1]=deaths.parish[121:125,1] ;  #missing vals for All Hallows Barking
  deaths.parish=rbind(deaths.parish[1:120,],deaths.b);
  deaths.parish[86,!is.na(t(bills$b1625))]=t(bills$b1625)[!is.na(t(bills$b1625))];
  rm(deaths.b,deaths);
  #chooses rich and poor parishes by percent big houses
  b1=bills$pcbighses[1:97];
  b1=(b1>=median(b1,na.rm=T));
  b1[c(2,95)]=T ;   #AH bread st and St Swithin assumed large: surrounded by large
  b1[is.na(b1)]=F;  #others assumed small
  city.rich=(1:97)[b1];
  city.poor=(1:97)[!b1];
  #crises by area
  row.names(deaths.parish)=1540:1665
  d.rich=deaths.parish[,1:97]
  d.rich=d.rich[,city.rich]
  d.poor=deaths.parish[,1:97]
  d.poor=d.poor[,city.poor]
  d.citlib=deaths.parish[,1:113]
  d.lib=deaths.parish[,98:113]
  d.out=deaths.parish[,114:125]
d.west=deaths.parish[,126:130]
  d.tot=deaths.parish[,1:130]
  
  crisis.ratio=function(x,n,j=5){
    #ratio of crisis mortality in district in year n relative to j previous years
    a1=x[(n-j):n,]
    a1=a1[,!is.na(a1[j+1,])]
    a1=a1[,!is.na(colSums(a1))]
    a2=rowSums(a1)
    round(a2[j+1]/median(a2[1:j]),1)
  }
  
  plague.years=c(24,54,64,86,97,126)
  districts=list(d.rich,d.poor,d.lib,d.citlib,d.out,d.west,d.tot)
  crises=matrix(NA,nrow=length(plague.years),ncol=length(districts))
  for(i in 1:length(plague.years)){
    for (j in 1:length(districts)){
      crises[i,j]=crisis.ratio(districts[[j]],plague.years[i],5)
    }
  }
  
  crises=as.data.frame(crises)
  names(crises)=c("Intra rich","Intra poor","Extra","City","Out-Parishes","Westminster","Total");
  row.names(crises)=row.names(deaths.parish)[plague.years]
  library(xtable)
  a1=xtable(crises,caption="Relative mortality during plague crises.",label="tab:relative_mortality")
  digits(a1)=1
  print(a1,booktabs=T)  # an ordinary table
  
#####figure for beamer presentation
c1=crises[-c(2,5),c(4,1,2,3,5,6)]   #remove 1593 1636
c1$year=factor(c(1563,1603,1625,1665),ordered=T)
library(ggplot2)
library(reshape)
c2=melt(c1,id="year")
names(c2)[2:3]=c("Area","Mortality")
ggplot(c2,aes(year,Mortality))+geom_bar(stat="identity",fill="blue")+facet_wrap(~Area)+theme_bw()+
  theme(plot.background = element_rect(fill='white'), 
        axis.title.x = element_blank(),
        axis.title.y = element_blank(),
        text=element_text(colour = "grey30", size = 20),
        axis.text.x=element_text(angle = 0))
ggsave("b_relative_mortality.pdf")


##########plot biraben international plague data

rm(list=ls())
setwd("~/Dropbox/workspace/london/paper/paper_data/")
bir=read.csv("Biraben.csv")
bir[is.na(bir)]=0
bir=bir[,-c(12:13)]   #leave out Britain and total
names(bir)[2]="Spain"
names(bir)[5]="Britain"
bir=bir[,1:6]
bir=subset(bir,Year<1730)

library(ggplot2)
library(reshape)
bir1=melt(bir,id="Year")
names(bir1)=c("Year","Country","Plague")

ggplot(bir1,aes(Year,Plague))+geom_line(colour="blue")+facet_grid(Country~.,scales="free_y")+theme_bw()+
  opts(axis.text.x=theme_text(colour="grey50",size=11,angle=-0),
       axis.text.y=theme_text(colour="grey50",size=11,hjust=1),
       axis.title.y=theme_text(colour="grey40",size=11,angle=90))
ggsave("~/Dropbox/workspace/london/paper/figures/biraben.pdf",width=8)
  
  ################################Table of relative births#####################
  #  <<tabular-relative_births, echo=FALSE, results='asis'>>= 
  rm(list=ls())
  setwd("~/Dropbox/workspace/london/paper/paper_data/")
  load("births_annual.Rda");
  births.parish=births[1:126,1:130]
  load("london_bills.Rda");
  bills=bills[1:130,];
  #births.parish=births.total.mgcv  ;
  
  #chooses rich and poor parishes by percent big houses
  b1=bills$pcbighses[1:97];
  b1=(b1>=median(b1,na.rm=T));
  b1[c(2,95)]=T ;   #AH bread st and St Swithin assumed large: surrounded by large
  b1[is.na(b1)]=F;  #others assumed small
  city.rich=(1:97)[b1];
  city.poor=(1:97)[!b1];
  #crises by area
  row.names(births.parish)=1540:1665
  d.rich=births.parish[,1:97]
  d.rich=d.rich[,city.rich]
  d.poor=births.parish[,1:97]
  d.poor=d.poor[,city.poor]
  d.citlib=births.parish[,1:113]
  d.lib=births.parish[,98:113]
  d.out=births.parish[,114:125]
d.west=births.parish[,126:130]
  d.tot=births.parish[,1:125]
  
  crisis.ratio=function(x,n,j=5){
    #ratio of crisis mortality in district in year n relative to j previous years
    a1=x[(n-j):n,]
    a1=a1[,!is.na(a1[j+1,])]
    a1=a1[,!is.na(colSums(a1))]
    a2=rowSums(a1)
    round(a2[j+1]/median(a2[1:j]),1)
  }
  
  plague.years=c(24,54,64,86,97,126)
  districts=list(d.rich,d.poor,d.lib,d.citlib,d.out,d.west,d.tot)
  crises=matrix(NA,nrow=length(plague.years),ncol=length(districts))
  for(i in 1:length(plague.years)){
    for (j in 1:length(districts)){
      crises[i,j]=crisis.ratio(districts[[j]],plague.years[i],5)
    }
  }
  
  crises=as.data.frame(crises)
names(crises)=c("Intra rich","Intra poor","Extra-m.","City","Out-Parishes","Westminster","Total");
  row.names(crises)=row.names(births.parish)[plague.years]
  library(xtable)
  a1=xtable(crises,caption="Relative mortality during plague crises.",label="tab:relative_mortality")
  digits(a1)=1
  print(a1,booktabs=T)  # an ordinary table

####beamer plot of fall in plague years
c1=crises[-c(2,5),c(4,1,2,3,5,6)]   #remove 1593 1636
c1$year=factor(c(1563,1603,1625,1665),ordered=T)
library(ggplot2)
library(reshape)
c2=melt(c1,id="year")
names(c2)[2:3]=c("Area","Mortality")
ggplot(c2,aes(year,Mortality))+geom_bar(stat="identity",fill="blue")+facet_wrap(~Area)+theme_bw()+
  theme(plot.background = element_rect(fill='white'), 
        axis.title.x = element_blank(),
        axis.title.y = element_blank(),
        text=element_text(colour = "grey30", size = 20),
        axis.text.x=element_text(angle = 0))
ggplot(c2,aes(year,Mortality))+geom_dotplot(stat="identity",aes(fill=year))+facet_grid(~Area)+theme_bw()+
  theme(plot.background = element_rect(fill='white'), 
        axis.title.x = element_blank(),
        axis.title.y = element_blank(),
        text=element_text(colour = "grey30", size = 20),
        axis.text.x=element_text(angle = -90))
ggsave("b_fall_births_plague.pdf") 
  ####################plague mortality relative to previous years##########################################
  <<crisis_map,fig=TRUE,width=8,height=8,out.width=\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
    setwd("~/Dropbox/workspace/london/paper/paper_data/")
  rm(list=ls())
  library(sp)
  library(RColorBrewer)
  library(colorspace)
  
  #Plots of annual imputed deaths in plague years relative to median over previous 5 years
  load("map_london.Rda")
  
  london.map=london.map[1:130,]   #put into same order as deaths
  load("london_bills.Rda")
  bills=bills[1:130,]
  
  
  #PLOT DEATH RATES IN PLAGUE YEARS
  load("deaths_annual.Rda")  #recorded deaths
  
  deaths.total=deaths[,1:130]   #use recorded burials
  deaths.total[86,!is.na(t(bills$b1625))]=t(bills$b1625)[!is.na(t(bills$b1625))]; #use bills for 1625
  
  #Deaths on plague years relative to deaths in previous years
  crises=data.frame("d1563"=t(deaths.total[24,]/apply(deaths.total[19:23,],2,median,na.rm=T)),
                    "d1593"=t(deaths.total[54,]/apply(deaths.total[49:53,],2,median,na.rm=T)),
                    "d1603"=t(deaths.total[64,]/apply(deaths.total[59:63,],2,median,na.rm=T)),
                    "d1625"=t(deaths.total[86,]/apply(deaths.total[81:85,],2,median,na.rm=T)),
                    "d1636"=t(deaths.total[97,]/apply(deaths.total[92:96,],2,median,na.rm=T)),
                    "d1665"=bills$b1665/apply(subset(bills,select=c(b1660,b1661,b1662,b1663,b1664)),1,median,na.rm=T)
                    )
  names(crises)=c("1563","1593","1603","1625","1636","1665")
  crises[crises==NaN]=NA
  crises1=as.data.frame(lapply(crises,cut,breaks=c(0,2,4,5,7,1000),
                               labels=c("Up to 2","2 to 4","4 to 5","5 to 7","Over 7")))
  names(crises1)=c("d1563","d1593","d1603","d1625","d1636","d1665")
  l.map=london.map[1:130,]
  l.map@data=cbind(london.map@data[1:130,],crises1)
  #rv=list("sp.lines",thames,col="grey")
  br=list("sp.lines",bridge,col="black")
  rv1=list("sp.polygons",river,col="grey",fill = 384)
  wl=list("sp.lines",wall,lwd=2)
  pdf("~/Dropbox/workspace/london/paper/figures/relative_plague_mortality.pdf",height=10,width=6)
  spplot(l.map,c("d1636","d1665","d1603","d1625","d1563","d1593"),col=grey(.5), layout=c(2,3),sp.layout=list(rv1,wl,br),as.Table=T,
         col.regions=brewer.pal(5,"Purples"),xlim=c(530000,535100),ylim=c(179200,184200))
  dev.off()
###make wide for beamer
pdf("~/Dropbox/workspace/london/paper/figures/relative_plague_mortality_b.pdf",height=6,width=9)
spplot(l.map,c("d1625","d1636","d1665","d1563","d1593","d1603"),col=grey(.5), layout=c(3,2),sp.layout=list(rv1,wl,br),as.Table=T,
       col.regions=brewer.pal(5,"Purples"),xlim=c(530000,535100),ylim=c(179200,184200))
dev.off()

  
 
  
  #############################Compare baptism estimates with Graunt totals############################
  <<predicted_vs_bills_births,fig=TRUE,width=6,height=6,out.width=\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
   
    rm(list=ls())
    setwd("~/Dropbox/workspace/london/paper/paper_data/")
  library(ggplot2)
  library(gtable) 
  library(ggplot2)
  library(zoo)
  library(reshape)
  load("Graunt_totals.Rda")
  load("births_imputed.Rda")
  load("births_annual.Rda")
  graunt=data.frame(births.graunt=graunt.totals$births)
  graunt=graunt[1:63,]
  graunt=as.zoo(ts(graunt,1603))
births.imputed=births.imputed[1:120,]
  imputed1=data.frame(births.total=apply(births.imputed[,1:130],1,sum),
                      births.liberties=apply(births.imputed[,98:113],1,sum),
                      births.city=apply(births.imputed[,1:97],1,sum),
                      births.outparishes=apply(births.imputed[,114:125],1,sum),
                      births.west=apply(births.imputed[,126:130],1,sum))
  imputed=data.frame( births.total=apply(births.imputed[,-c(115,118,121,122,124,125,127,130)],1,sum,na.rm=T),
                     births.liberties=apply(births.imputed[,98:113],1,sum),
                     births.city=apply(births.imputed[,1:97],1,sum),
                     births.outparishes=apply(births.imputed[,114:125],1,sum),
                     births.west=apply(births.imputed[,126:130],1,sum))

  
  
  imputed[98:(nrow(imputed)),]=imputed1[98:nrow(imputed),]  #include distant parishes from 1637
  imputed=as.zoo(ts(imputed,1541))
  c1=merge(graunt,imputed)
  c1=as.data.frame(c1)
  names(c1)[1]=c("graunt.baptisms")
#c1$births.westminster=apply(births[11:126,c(126,128,130)],1,sum,na.rm=T)
  c1$date=seq(as.Date("1541-01-01"),by="year",length=nrow(c1))
c1=c1[20:120,]   #remove 1550s

plotfunc <- function(x,plot.title,xlab,ylab){
  x +
    geom_line() +
    theme(axis.text.x = element_text(colour="grey50",size=9,angle=-0),
          axis.text.y = element_text(colour="grey50",size=9,hjust=1),
          axis.title.y = element_text(colour="grey40",size=9,angle=90),
          plot.title = element_text(size=10))+
    labs(title=plot.title, x=xlab, y=ylab)+
    scale_colour_hue("")+
    theme_bw()
}

 ###ratio of briths to deaths 
#   c2=within(c1,{City=births.city/deaths.city;Extra.mural=births.liberties/deaths.liberties;Out.Parishes=births.outparishes/deaths.outparishes})
#   c2=c2[,-(1:(ncol(c1)-1))]
#   c2=c2[,c(4:1)]
#   c3=melt(c2,id="date")
# p <- ggplot(c3,aes(date,value,colour=variable))
# p3=plotfunc(p,plot.title="Ratio of Baptisms to Funerals.",xlab="",ylab="Ratio")+ theme(legend.position="none")


###########births by region
  c2=within(c1,{Intra.mural=births.city;Extra.mural=births.liberties;Out.parishes=births.outparishes;
                Westminster=births.west})
  c2=c2[,-(1:(ncol(c1)-1))]
  c2=c2[,c(5:1)]
  c3=melt(c2,id="date")
p <- ggplot(c3,aes(date,value,colour=variable))
p2=plotfunc(p,plot.title="Baptisms by Area",xlab="",ylab="Baptisms")+
  theme(legend.position=c(0.1,0.7))

###############total births compared with graunt
  c2=within(c1,{Estimate=births.total;Bills=graunt.baptisms})
  c2=c2[,-(1:(ncol(c1)-1))]
  c2=c2[,c(3:1)]
  c3=melt(c2,id="date")
p <- ggplot(c3,aes(date,value,colour=variable))
p1=plotfunc(p,plot.title="Total Baptisms",xlab="",ylab="Baptisms")+
  theme(legend.position=c(0.05,0.8))
  
  
  
  
  grid.newpage()
pdf("~/Dropbox/workspace/london/paper/figures/total_baptisms.pdf",height=6,width=9)
  pushViewport(viewport(layout = grid.layout(2,1))) 
  
  print(p1, vp=viewport(layout.pos.row=1,layout.pos.col=1))
  print(p2, vp=viewport(layout.pos.row=2,layout.pos.col=1))
  #print(p3, vp=viewport(layout.pos.row=3,layout.pos.col=1))
  dev.off()


#################Ratio of births to deaths by region#################
rm(list=ls())
setwd("~/Dropbox/workspace/london/paper/paper_data/")
library(colorspace)
library(sp)
library(methods)
library(reshape)
library(ggplot2)
load("births_annual.Rda")
births=births[as.numeric(row.names(births))>=1550&as.numeric(row.names(births))<=1640,]
births=births[2:90,]+0*births[1:89,]+0*births[3:91,]      #years preceded or followed by all missing are set to missing
births.orig=births
load("deaths_annual.Rda")
deaths=deaths[as.numeric(row.names(deaths))>=1550&as.numeric(row.names(deaths))<=1640,]
deaths=deaths[2:90,]+0*deaths[1:89,]+0*deaths[3:91,]      #years preceded or followed by all missing 
deaths.orig=deaths

deaths[is.na(births.orig)]=NA
births[is.na(deaths.orig)]=NA
load("london_bills.Rda")
#chooses rich and poor parishes by percent big houses
b1=bills$pcbighses[1:97];
b1=(b1>=median(b1,na.rm=T));
b1[c(2,95)]=T ;   #AH bread st and St Swithin assumed large: surrounded by large
b1[is.na(b1)]=F;  #others assumed small
city.rich=(1:97)[b1];
city.poor=(1:97)[!b1];

b1=data.frame(City=apply(births[,1:113],1,sum,na.rm=T),Total=apply(births,1,sum,na.rm=T),Intra.rich=apply(births[,city.rich],1,sum,na.rm=T),Intra.poor=apply(births[,city.poor],1,sum,na.rm=T),Extra.mural=apply(births[,98:113],1,sum,na.rm=T),Out.parishes=apply(births[,114:129],1,sum,na.rm=T))
d1=data.frame(City=apply(deaths[,1:113],1,sum,na.rm=T),Total=apply(deaths,1,sum,na.rm=T),Intra.rich=apply(deaths[,city.rich],1,sum,na.rm=T),Intra.poor=apply(deaths[,city.poor],1,sum,na.rm=T),Extra.mural=apply(deaths[,98:113],1,sum,na.rm=T),Out.parishes=apply(deaths[,114:129],1,sum,na.rm=T))
ratio=round(b1/d1,3)
ratio$year=1551:1639
ratio=subset(ratio,year>=1560)
r1=melt(ratio[,-1],id="year")
ggplot(r1,aes(year,value))+geom_bar(stat="identity",fill="#00BFC4")+facet_grid(variable~.,scales="fixed")+xlab("")+ ylab("") +
  theme_bw()+  geom_hline(yintercept=1,colour="pink")+
  opts(axis.text.x=theme_text(colour="grey50",size=11),axis.text.y=theme_text(colour="grey50",size=11,hjust=1),
       axis.title.y=theme_text(colour="grey40",size=14,angle=90),
       axis.title.x=theme_text(colour="grey40",size=14,angle=0))
ggsave(file="~/Dropbox/workspace/london/paper/figures/birth_death_ratio.pdf",height=8,width=12)
###quantiles of birth-death ratio for different areas
round(apply(ratio,2,quantile),1)
round(apply(ratio[41:80,],2,quantile),1)
creighton.ratio=c(3150,3370,3568,2949,3433)/c(7830,3406,2873,3931,6762)  #Creighton bills 78--82
cbind.data.frame(creighton.ratio,ratio[19:23,1])  
###annual deficit###
load("deaths_imputed.Rda")
d1=apply(deaths.imputed[20:99,],1,sum)
deficit=as.data.frame(matrix(round((1-ratio$Total)*d1),ncol=10,byrow=T))   #annual excess deaths by decade, 1560-1639
lon=round(apply(deficit,1,mean))  #average excess deaths per year
load("ws.rda")  #wrigley totals
nat=matrix(round(with(data.ws[20:99,],(cbr-cdr)*popn/1000)),,ncol=10,byrow=T)
nat=round(apply(nat,1,mean))
round(lon/nat,2)   #london deficit as fraction of national natural increase




#########################Child deaths########################
rm(list=ls())
setwd("~/Dropbox/workspace/london/paper/paper_data/")
load("children.Rda")
library(reshape)
library(ggplot2)
library(gtable) 
plotfunc <- function(x,plot.title,xlab,ylab){
  x +
    geom_line() +
    theme(axis.text.x = element_text(colour="grey50",size=9,angle=-0),
          axis.text.y = element_text(colour="grey50",size=9,hjust=1),
          axis.title.y = element_text(colour="grey40",size=9,angle=90),
          plot.title = element_text(size=10))+
    labs(title=plot.title, x=xlab, y=ylab)+
    scale_colour_hue("")+
    theme_bw()
}
c3=melt(child.share,id="date")
p <- ggplot(c3,aes(date,value,colour=variable))
p2=plotfunc(p,plot.title="Share of Deaths Classified as Children",xlab="",ylab="Share")+
  theme(legend.position=c(0.1,0.85))

c3=melt(child.birth,id="date")
p <- ggplot(c3,aes(date,value,colour=variable))
p3=plotfunc(p,plot.title="Child Deaths Relative to Baptisms",xlab="",ylab="Ratio")+
  theme(legend.position=c(0.1,0.85))

grid.newpage() 
pdf("~/Dropbox/workspace/london/paper/figures/children.pdf",height=8,width=8)
pushViewport(viewport(layout = grid.layout(2,1))) 
print(p2, vp=viewport(layout.pos.row=1,layout.pos.col=1))
print(p3, vp=viewport(layout.pos.row=2,layout.pos.col=1))
dev.off()
  #########################Annual and crisis deaths###########################
 # <<annual_crises,fig=TRUE,width=6,height=4,out.width=\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
 #   setwd("~/Dropbox/workspace/london/paper/paper_data/")
  library(ggplot2)
  library(gridExtra) 
  library(zoo)
  library(reshape)
  rm(list=ls())
  load("total_farrington.Rda")
  london.crises=data.frame(deaths=london.farr@observed,crisis=london.farr@observed-london.farr@upperbound)
  names(london.crises)=c("deaths","crisis")
  london.crises$crisis[london.crises$crisis<0]=0
  c1=cumsum(london.crises$crisis)
  c2=c(0,c1[seq(52,to=length(c1),by=52)])
  c2=c2[2:length(c2)]-c2[1:(length(c2)-1)]
  d1=cumsum(london.crises$deaths)
  d2=c(0,d1[seq(52,to=length(d1),by=52)])
  d2=d2[2:length(d2)]-d2[1:(length(d2)-1)]
  years.crisis=data.frame("Total Deaths"=d2,"Crisis Share"=c2/d2,date=london.farr@start[1]+seq(0,by=1,length.out=length(c2)))
  m1=melt(years.crisis,id="date")
  ggplot(m1,aes(date,value))+geom_bar(stat="identity",fill="#00BFC4")+facet_grid(variable~.,scales="free_y")+xlab("")+ ylab("") +
    theme_bw()+
    opts(axis.text.x=theme_text(colour="grey50",size=11),axis.text.y=theme_text(colour="grey50",size=11,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=14,angle=90),
         axis.title.x=theme_text(colour="grey40",size=14,angle=0))
  ggsave(file="~/Dropbox/workspace/london/paper/figures/crisis_deaths.pdf",height=4,width=6)
#share of crisis deaths
years.crisis$crisis=round(years.crisis[,1]*years.crisis[,2])
sum(years.crisis$Crisis.Share[1:41]>0.1)
sum(years.crisis$Crisis.Share[42:106]>0.1)
sum(years.crisis$crisis[1:41])/sum(years.crisis$Tot[1:41])
sum(years.crisis$crisis[42:105])/sum(years.crisis$Tot[42:105])
  
  
  ##################################Weekly spread##############################
 # <<spread_crises,fig=TRUE,width=25,height=30,out.width=1.2\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
 #   setwd("~/Dropbox/workspace/london/paper/paper_data/")
##########weekly spread of crises###################

rm(list=ls())
load("map_london.Rda")
library(RColorBrewer)
br=list("sp.lines",bridge)
rv=list("sp.polygons",river,col="grey",fill = 384)
wl=list("sp.lines",wall,lwd=3)
a2=london.map[1:130,]

load("farr_1563.Rda")
farr=farr.1563
ratio=farr@observed/farr@upperbound
ratio[!is.finite(ratio)]=0
ratio[ratio<1]=0
ratio=as.data.frame(ratio)
r1=data.frame(matrix(NA,51,130))
names(r1)=a2$Parish
r1[,match(names(ratio),a2$Parish)]=ratio
ratio=r1
gg=as.data.frame(t(ratio))
names(gg)=paste("week_",1:ncol(gg),"_1563",sep="")
gg2=lapply(gg,function(x){cut(x,breaks=c(0,1,2,4,6,1e7),labels=c("0","1-2","2-4","4-6",">6"),include.lowest=T,
                              ordered_result=T)})
gg2.1563=data.frame(gg2)
a3=a2
a3@data=cbind(a3@data,gg2.1563)
p1563=spplot(a3,c("week_26_1563","week_27_1563","week_28_1563",
                  "week_29_1563","week_30_1563","week_31_1563","week_32_1563",
                  "week_33_1563","week_34_1563","week_35_1563",
                  "week_36_1563","week_37_1563","week_38_1563",
                  "week_39_1563","week_40_1563","week_41_1563"),
             col=grey(.5),cuts=4, sp.layout=list(rv,wl,br),col.regions=brewer.pal(5,"YlOrBr"),layout=c(4,4), 
             as.table=T,xlim=c(530000,535100),ylim=c(179500,184200))
pdf("spread1563.pdf",width=8)
print(p1563)
dev.off()

load("farr_1603.Rda")
farr=farr.1603
ratio=farr@observed/farr@upperbound
ratio[!is.finite(ratio)]=0
ratio[ratio<1]=0
ratio=as.data.frame(ratio)
r1=data.frame(matrix(NA,51,130))
names(r1)=a2$Parish
r1[,match(names(ratio),a2$Parish)]=ratio
ratio=r1
gg=as.data.frame(t(ratio))
names(gg)=paste("week_",1:ncol(gg),"_1603",sep="")
gg2=lapply(gg,function(x){cut(x,breaks=c(0,1,2,4,6,1e7),labels=c("0","1-2","2-4","4-6",">6"),include.lowest=T,
                              ordered_result=T)})
gg2.1603=data.frame(gg2)
a3=a2
a3@data=cbind(a3@data,gg2.1603)
p1603=spplot(a3,c("week_17_1603","week_18_1603","week_19_1603","week_20_1603","week_21_1603",
                  "week_22_1603","week_23_1603",
                  "week_24_1603","week_25_1603","week_26_1603","week_27_1603","week_28_1603",
                  "week_29_1603","week_30_1603","week_31_1603","week_32_1603"),
             col=grey(.5),cuts=4, sp.layout=list(rv,wl,br),col.regions=brewer.pal(5,"YlOrBr"),layout=c(4,4), 
             as.table=T,xlim=c(530000,535100),ylim=c(179500,184200))
pdf("spread1603.pdf",width=8)
print(p1603)
dev.off()

load("farr_1625.Rda")
farr=farr.1625
ratio=farr@observed/farr@upperbound
ratio[!is.finite(ratio)]=0
ratio[ratio<1]=0
ratio=as.data.frame(ratio)
r1=data.frame(matrix(NA,51,130))
names(r1)=a2$Parish
r1[,match(names(ratio),a2$Parish)]=ratio
ratio=r1
gg=as.data.frame(t(ratio))
names(gg)=paste("week_",1:ncol(gg),"_1625",sep="")
gg2=lapply(gg,function(x){cut(x,breaks=c(0,1,2,4,6,1e7),labels=c("0","1-2","2-4","4-6",">6"),include.lowest=T,
                              ordered_result=T)})
gg2.1625=data.frame(gg2)
a3=a2
a3@data=cbind(a3@data,gg2.1625)
p1625=spplot(a3,c("week_17_1625","week_18_1625","week_19_1625","week_20_1625","week_21_1625",
                  "week_22_1625","week_23_1625",
                  "week_24_1625","week_25_1625","week_26_1625","week_27_1625","week_28_1625",
                  "week_29_1625","week_30_1625","week_31_1625","week_32_1625"),
             col=grey(.5),cuts=4, sp.layout=list(rv,wl,br),col.regions=brewer.pal(5,"YlOrBr"),layout=c(4,4), 
             as.table=T,xlim=c(530000,535100),ylim=c(179500,184200))
pdf("spread1625.pdf",width=8)
print(p1625)
dev.off()

load("farr_1665.Rda")
farr=farr.1665
ratio=farr@observed/farr@upperbound
ratio[!is.finite(ratio)]=0
ratio[ratio<1]=0
ratio=as.data.frame(ratio)
r1=data.frame(matrix(NA,51,130))
names(r1)=a2$Parish
r1[,match(names(ratio),a2$Parish)]=ratio
ratio=r1
gg=as.data.frame(t(ratio))
names(gg)=paste("week_",1:ncol(gg),"_1665",sep="")
gg2=lapply(gg,function(x){cut(x,breaks=c(0,1,2,4,6,1e7),labels=c("0","1-2","2-4","4-6",">6"),include.lowest=T,
                              ordered_result=T)})
gg2.1665=data.frame(gg2)
a3=a2
a3@data=cbind(a3@data,gg2.1665)
p1665=spplot(a3,c("week_17_1665","week_18_1665","week_19_1665","week_20_1665","week_21_1665",
                  "week_22_1665","week_23_1665",
                  "week_24_1665","week_25_1665","week_26_1665","week_27_1665","week_28_1665",
                  "week_29_1665","week_30_1665","week_31_1665","week_32_1665"),
             col=grey(.5),cuts=4, sp.layout=list(rv,wl,br),col.regions=brewer.pal(5,"YlOrBr"),layout=c(4,4), 
             as.table=T,xlim=c(530000,535100),ylim=c(179500,184200))
pdf("spread1665.pdf",width=8)
print(p1665)
dev.off()


  ########################################Spread 1665###############################
  <<spread_1665,fig=TRUE,out.width=\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
    setwd("paper_data/")
  rm(list=ls())
  load("map_london.Rda")
  library(RColorBrewer)
  br=list("sp.lines",bridge)
  rv=list("sp.polygons",river,col="grey",fill = 384)
  wl=list("sp.lines",wall,lwd=3)
  a2=london.map[1:130,]
  load("farr_1665.Rda")
  farr=farr.1665
  ratio=farr@observed/farr@upperbound
  ratio[!is.finite(ratio)]=0
  ratio[ratio<1]=0
  ratio=as.data.frame(ratio)
  r1=data.frame(matrix(NA,51,130))
  names(r1)=a2$Parish
  r1[,match(names(ratio),a2$Parish)]=ratio
  ratio=r1
  gg=as.data.frame(t(ratio))
  names(gg)=paste("week_",1:ncol(gg),"_1665",sep="")
  gg2=lapply(gg,function(x){cut(x,breaks=c(0,1,2,4,6,1e7),labels=c("0","1-2","2-4","4-6",">6"),include.lowest=T,
                                ordered_result=T)})
  gg2.1665=data.frame(gg2)
  a3=a2
  a3@data=cbind(a3@data,gg2.1665)
  pdf("~/Dropbox/workspace/london/paper/figures/spread_1665.pdf",height=10,width=6)

  spplot(a3,c("week_17_1665","week_18_1665","week_19_1665","week_20_1665","week_21_1665","week_22_1665","week_23_1665",
              "week_24_1665","week_25_1665","week_26_1665","week_27_1665","week_28_1665",
              "week_29_1665","week_30_1665","week_31_1665"),
         col=grey(.9),cuts=4, sp.layout=list(rv,wl,br),col.regions=brewer.pal(5,"YlOrBr"),layout=c(3,5), 
         as.table=T,xlim=c(530000,535100),ylim=c(179500,184200))
  dev.off()
#############same map wide for beamer
pdf("~/Dropbox/workspace/london/paper/figures/spread_1665_b.pdf",height=6,width=10)

spplot(a3,c("week_17_1665","week_19_1665","week_21_1665","week_23_1665",
            "week_24_1665","week_25_1665","week_26_1665","week_27_1665",
            "week_28_1665","week_29_1665","week_30_1665","week_31_1665"),
       col=grey(.9),cuts=4, sp.layout=list(rv,wl,br),col.regions=brewer.pal(5,"YlOrBr"),layout=c(4,3), 
       as.table=T,xlim=c(530000,535100),ylim=c(179500,184200))
dev.off()

  
  
  ####################################Seasonal share of mortality#############################
 # <<seasonality,fig=TRUE,out.width=\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>=
  #  setwd("paper_data/")
rm(list=ls())
  load("deaths_weekly.Rda")
  decade=10*floor(as.numeric(row.names(deaths))/10)
  d1=deaths[(decade>1550)&decade<1750,]
  d2=data.frame(Total=apply(d1[,1:125],1,sum,na.rm=T),City=apply(d1[,1:97],1,sum,na.rm=T),
                Liberties=apply(d1[,89:113],1,sum,na.rm=T),Out.Parishes=apply(d1[,114:125],1,sum,na.rm=T),
                time=seq(as.numeric(row.names(d1))[1],by=1/52,length=nrow(d1)),week=rep(1:52,nrow(d1)/52))
  d2=within(d2,{year=floor(time)})
  library(plyr)
  d3=ddply(d2,.(year),numcolwise(sum))
  d2$Total.share=d2$Total/rep(d3$Total,each=52)  #week's share of annual mortality
  d2$City.share=d2$City/rep(d3$City,each=52)  #week's share of annual mortality
  d2$Liberties.share=d2$Liberties/rep(d3$Liberties,each=52)  
  d2$Out.Parishes.share=d2$Out.Parishes/rep(d3$Out.Parishes,each=52)
  library(reshape)
  library(ggplot2)
  
  
  
  
  ##################plot monthly averages###################
  library(plyr)
  a1=d2$City.share        #4 week months
  a2=cumsum(a1)
  b1=seq(from=8,to=length(a2),by=4)
  a3=c(a2[4],a2[b1]-a2[b1-4])
  monthly.shares=data.frame(time=seq(1560,by=1/13,length=length(a3)),month=as.factor(rep(1:13,length(a3)/13)),City=a3)
  a1=d2$Liberties.share        #4 week months
  a2=cumsum(a1)
  b1=seq(from=8,to=length(a2),by=4)
  a3=c(a2[4],a2[b1]-a2[b1-4])
  monthly.shares$Liberties=a3
  a1=d2$Out.Parishes.share        #4 week months
  a2=cumsum(a1)
  b1=seq(from=8,to=length(a2),by=4)
  a3=c(a2[4],a2[b1]-a2[b1-4])
  monthly.shares$Out.Parishes=a3
  
  b1=subset(monthly.shares,(time>=1613)&(time<1624))
  b2=ddply(b1,.(month),numcolwise(mean))
  b2$time=NULL
  b3=melt(b2,id="month")
  b3$month=as.numeric(b3$month)
  p1=ggplot(b3,aes(x=month,y=value,colour=variable))+geom_line()+
    theme_bw()+
    xlab("")+ylab("")+scale_colour_hue("")+ylim(0.05,0.11)+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="1613-1623",
         legend.position="none")
  
  b1=subset(monthly.shares,(time>=1650)&(time<1664))
  b2=ddply(b1,.(month),numcolwise(mean))
  b2$time=NULL
  b3=melt(b2,id="month")
  b3$month=as.numeric(b3$month)
  p2=ggplot(b3,aes(x=month,y=value,colour=variable))+geom_line()+
    theme_bw()+
    xlab("")+ylab("")+scale_colour_hue("")+ylim(0.05,0.11)+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="1650-1663",
         legend.position="none")
  
  b1=subset(monthly.shares,(time>=1670)&(time<1690))
  b2=ddply(b1,.(month),numcolwise(mean))
  b2$time=NULL
  b3=melt(b2,id="month")
  b3$month=as.numeric(b3$month)
  p3=ggplot(b3,aes(x=month,y=value,colour=variable))+geom_line()+
    theme_bw()+
    xlab("")+ylab("")+scale_colour_hue("")+ylim(0.05,0.11)+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="1670-1689",
         legend.position="none")
  
  b1=subset(monthly.shares,(time>=1690)&(time<1710))
  b2=ddply(b1,.(month),numcolwise(mean))
  b2$time=NULL
  b3=melt(b2,id="month")
  b3$month=as.numeric(b3$month)
  p4=ggplot(b3,aes(x=month,y=value,colour=variable))+geom_line()+
    theme_bw()+
    xlab("")+ylab("")+scale_colour_hue("")+ylim(0.05,0.11)+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="1690-1709",
         legend.position="none")
  
  b1=subset(monthly.shares,(time>=1710)&(time<1730))
  b2=ddply(b1,.(month),numcolwise(mean))
  b2$time=NULL
  b3=melt(b2,id="month")
  b3$month=as.numeric(b3$month)
  p5=ggplot(b3,aes(x=month,y=value,colour=variable))+geom_line()+
    theme_bw()+
    xlab("")+ylab("")+scale_colour_hue("")+ylim(0.05,0.11)+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="1710-1729",
         legend.position="none")
  
  b1=subset(monthly.shares,(time>=1730)&(time<1750))
  b2=ddply(b1,.(month),numcolwise(mean))
  b2$time=NULL
  b3=melt(b2,id="month")
  b3$month=as.numeric(b3$month)
  p6=ggplot(b3,aes(x=month,y=value,colour=variable))+geom_line()+
    theme_bw()+
    xlab("")+ylab("")+scale_colour_hue("")+ylim(0.05,0.11)+
    opts(axis.text.x=theme_text(colour="grey50",size=9,angle=-0),
         axis.text.y=theme_text(colour="grey50",size=9,hjust=1),
         axis.title.y=theme_text(colour="grey40",size=9,angle=90),title="1730-1749",
         legend.position="none")
  
  library(gridExtra)
  grid.newpage()
  pdf("~/Dropbox/workspace/london/paper/figures/seasonality.pdf",height=8,width=8)
  pushViewport(viewport(layout = grid.layout(3,2))) 
  
  print(p1, vp=viewport(layout.pos.row=1,layout.pos.col=1))
  print(p2, vp=viewport(layout.pos.row=1,layout.pos.col=2))
  print(p3, vp=viewport(layout.pos.row=2,layout.pos.col=1))
  print(p4, vp=viewport(layout.pos.row=2,layout.pos.col=2))
  print(p5, vp=viewport(layout.pos.row=3,layout.pos.col=1))
  print(p6, vp=viewport(layout.pos.row=3,layout.pos.col=2))
  dev.off()
  
  
  ########################################Heatmap of monthely mortality####################
 # <<heatmap,fig=TRUE,out.width=\textwidth,echo=FALSE,warning=FALSE,message=FALSE,results='hide',cache=T>>= 
    a1=d2$City.share        #4 week months
  a2=cumsum(a1)
  b1=seq(from=8,to=length(a2),by=4)
  a3=c(a2[4],a2[b1]-a2[b1-4])
  c2=melt(matrix(a3,ncol=13,byrow=T))
  c2$X1=c2$X1+1559
  names(c2)=c("Year","Month","Intra.mural")
  a1=d2$Liberties.share        #4 week months
  a2=cumsum(a1)
  b1=seq(from=8,to=length(a2),by=4)
  a3=c(a2[4],a2[b1]-a2[b1-4])
  a4=melt(matrix(a3,ncol=13,byrow=T))      
  names(a4)=c("Year","Month","Extra.mural")
  c2$Extra.mural=a4$Extra.mural
  a1=d2$Out.Parishes.share        #4 week months
  a2=cumsum(a1)
  b1=seq(from=8,to=length(a2),by=4)
  a3=c(a2[4],a2[b1]-a2[b1-4])
  a4=melt(matrix(a3,ncol=13,byrow=T))      
  names(a4)=c("Year","Month","Out.parishes")
  c2$Out.parishes=a4$Out.parishes
  b1=melt(c2,id=c("Year","Month"))
  b1$value=cut(b1$value,breaks=quantile(b1$value,seq(0,1,1/6)))
  ggplot(b1, aes(x=Year, y=Month, fill=value)) + geom_tile() + facet_grid(variable~.)+scale_fill_brewer(palette=7) +  
    theme_bw()+xlab("")+ coord_equal(ratio = 1)+opts(legend.position="none")
  ggsave(file="~/Dropbox/workspace/london/paper/figures/heatmap.pdf",height=3,width=10)

####################Regional regressions using clark wage################
rm(list=ls())
setwd("~/Dropbox/workspace/london/paper/paper_data/")
load("deaths_imputed.Rda")
load("wage_london.Rda")
library(zoo)
deaths=deaths.imputed
deaths.region=data.frame(year=as.numeric(row.names(deaths)),total=apply(deaths[,1:125],1,sum),
                         city=apply(deaths[,1:97],1,sum),liberties=apply(deaths[,98:113],1,sum),
                         outparishes=apply(deaths[,114:125],1,sum),west=apply(deaths[,126:129],1,sum),
                         wage=wage.london$clark[1:124])
gr=deaths.region
gr[,-1]=log(gr[,-1])
#gr=gr[2:64,]-gr[1:63,]
gr1=as.zoo(ts(gr,1541))
gr2=lag(gr1,-1)
names(gr2)=paste("lag",names(gr1),sep=".")
gr3=lag(gr1,-2)
names(gr3)=paste("lag2",names(gr1),sep=".")
gra=merge(gr1,gr2,all=T)
gra=merge(gra,gr3,all=T)
gra=as.data.frame(gra)
gra=subset(gra,year>1559&year<1665)
gra$plague.year=0
gra$plague.year[gra$year==1563]=1
gra$plague.year[gra$year==1593]=1
gra$plague.year[gra$year==1603]=1
gra$plague.year[gra$year==1625]=1
gra$plague.year[gra$year==1636]=1
gra$post.plague.year=0
gra$post.plague.year[gra$year==1564]=1
gra$post.plague.year[gra$year==1594]=1
gra$post.plague.year[gra$year==1604]=1
gra$post.plague.year[gra$year==1626]=1
gra$post.plague.year[gra$year==1637]=1
gra$trend=1:nrow(gra)

gra1=subset(gra,select=c(total,lag.total,lag2.total,wage,lag.wage,lag2.wage,trend,plague.year,post.plague.year))
names(gra1)[1:3]=c("dependent","lag.dependent","lag2.dependent")
Total=(lm(dependent~trend+lag.dependent+lag2.dependent+wage+lag.wage+plague.year+post.plague.year,data=gra1))
gra1=subset(gra,select=c(city,lag.city,lag2.city,wage,lag.wage,lag2.wage,trend,plague.year,post.plague.year))
names(gra1)[1:3]=c("dependent","lag.dependent","lag2.dependent")
Intra=(lm(dependent~trend+lag.dependent+lag2.dependent+wage+lag.wage+plague.year+post.plague.year,data=gra1))
gra1=subset(gra,select=c(liberties,lag.liberties,lag2.liberties,wage,lag.wage,lag2.wage,trend,plague.year,post.plague.year))
names(gra1)[1:3]=c("dependent","lag.dependent","lag2.dependent")
Extra.m=(lm(dependent~trend+lag.dependent+lag2.dependent+wage+lag.wage+plague.year+post.plague.year,data=gra1))
gra1=subset(gra,select=c(outparishes,lag.outparishes,lag2.outparishes,wage,lag.wage,lag2.wage,trend,plague.year,post.plague.year))
names(gra1)[1:3]=c("dependent","lag.dependent","lag2.dependent")
Out.parishes=(lm(dependent~trend+lag.dependent+lag2.dependent+wage+lag.wage+plague.year+post.plague.year,data=gra1))
gra1=subset(gra,select=c(west,lag.west,lag2.west,wage,lag.wage,lag2.wage,trend,plague.year,post.plague.year))
names(gra1)[1:3]=c("dependent","lag.dependent","lag2.dependent")
West=(lm(dependent~trend+lag.dependent+lag2.dependent+wage+lag.wage+plague.year+post.plague.year,data=gra1))

library(texreg)
table=texreg(list(Total,Intra,Extra.m,Out.parishes,West),
             caption="Positive Checks in London, 1560--1664.",label="table: malthusian",
             model.names=c("Total","Intra","Extra","Out Parishes", "Westminster"))
###Plot of deaths versus wage
c1=subset(gra,plague.year==0)
c1=c1[,1:7]
names(c1)=c("year","Total","Intra.mural","Extra.mural","Out.parishes","Westminster","Wage")
c1$label=NA
c1$label[c1$year %in% c(1641,1664,1656,1592,1654,1582,1578,1570)]= 
  c1$year[c1$year %in% c(1641,1664,1656,1592,1654,1582,1578,1570)]

library(gtable)
library(ggplot2)

p1=ggplot(c1,aes(x=Wage,y=Total,label=label))+geom_point(aes(colour="black"),size=1.5)+
  geom_text(vjust=2,colour="grey50",size=3)+theme_bw()+
  opts(axis.text.x=theme_text(colour="grey50",size=11),axis.text.y=theme_text(colour="grey50",size=11,hjust=1),
       axis.title.y=theme_text(colour="grey40",size=14,angle=90),axis.title.x=theme_text(colour="grey40",size=14),
       legend.position="none")+stat_smooth()
p2=ggplot(c1,aes(x=Wage,y=Intra.mural,label=label))+geom_point(aes(colour="black"),size=1.5)+
  theme_bw()+
  opts(axis.text.x=theme_text(colour="grey50",size=11),axis.text.y=theme_text(colour="grey50",size=11,hjust=1),
       axis.title.y=theme_text(colour="grey40",size=14,angle=90),axis.title.x=theme_text(colour="grey40",size=14),
       legend.position="none")+stat_smooth()
p3=ggplot(c1,aes(x=Wage,y=Extra.mural,label=label))+geom_point(aes(colour="black"),size=1.5)+
  theme_bw()+
  opts(axis.text.x=theme_text(colour="grey50",size=11),axis.text.y=theme_text(colour="grey50",size=11,hjust=1),
       axis.title.y=theme_text(colour="grey40",size=14,angle=90),axis.title.x=theme_text(colour="grey40",size=14),
       legend.position="none")+stat_smooth()
p4=ggplot(c1,aes(x=Wage,y=Out.parishes,label=label))+geom_point(aes(colour="black"),size=1.5)+
  theme_bw()+
  opts(axis.text.x=theme_text(colour="grey50",size=11),axis.text.y=theme_text(colour="grey50",size=11,hjust=1),
       axis.title.y=theme_text(colour="grey40",size=14,angle=90),axis.title.x=theme_text(colour="grey40",size=14),
       legend.position="none")+stat_smooth()
grid.newpage()
pdf("~/Dropbox/workspace/london/paper/figures/wage_deaths.pdf",height=12,width=12)
pushViewport(viewport(layout = grid.layout(2,2))) 
print(p1, vp=viewport(layout.pos.row=1,layout.pos.col=1))
print(p2, vp=viewport(layout.pos.row=1,layout.pos.col=2))
print(p3, vp=viewport(layout.pos.row=2,layout.pos.col=1))
print(p4, vp=viewport(layout.pos.row=2,layout.pos.col=2))
dev.off()  
  @
  
  @
  
  @
  @